<?php
header('Access-Control-Allow-Origin: *');
require_once __DIR__ . '/../negocio/Garita.clase.php';
require_once __DIR__ . '/../util/Funciones.clase.php';

if(!isset($_POST["p_dni"])
    ||!isset($_POST["p_usuario"])
    ||!isset($_POST["p_garita"])
    ||!isset($_POST["p_tipo"])
    ){
    Funciones::imprimeJSON(200, "error", "Faltan parámetros");
    exit;
}

try{
    $obj = new Garita();
    $dni = $_POST["p_dni"];
    $codigo_usuario = $_POST["p_usuario"];
    $codigo_garita = $_POST["p_garita"];
    $tipo = $_POST["p_tipo"];

    if($tipo != "QR" && strlen($dni) <= 12) {
        $resultado = $obj->entradaRapidaDni($dni, $codigo_garita, $codigo_usuario);
        Funciones::imprimeJSON(200, "Entrada rápida", $resultado);
    }else{
        $codigoQrDecoded = base64_decode($dni);
        $LEER_TIPO_QR = "";
        if (strstr($codigoQrDecoded, 'cod_cond') && strstr($codigoQrDecoded, 'fecha_ini')){
            $LEER_TIPO_QR = "EXPIRABLE";
        } else if(strstr($codigoQrDecoded, 'cod_cond')){
            $LEER_TIPO_QR = "CONDUCTOR";
        }else if (strstr($codigoQrDecoded, 'cod_ve')){
            $LEER_TIPO_QR = "VEHICULO";
        } else if(strstr($codigoQrDecoded, 'rut_nomb')){
            $LEER_TIPO_QR = "TRANSPORTISTA";
        }

        switch ($LEER_TIPO_QR) {
            case "CONDUCTOR":
                $separador = explode("#", $codigoQrDecoded);
                $codigo_conductor = explode("=", $separador[0]);
                $codigo_conductor = $codigo_conductor[1];
                $codigo_empresa = explode("=", $separador[1]);
                $codigo_empresa = $codigo_empresa[1];
                $nombre_conductor = explode("=", $separador[2]);
                $nombre_conductor = $nombre_conductor[1];
                $dni_conductor = explode("=", $separador[5]);
                $dni_conductor = $dni_conductor[1];
                $resultado = $obj->entradaRapidaConductor($codigo_conductor, $codigo_empresa, $nombre_conductor, $dni_conductor, $codigo_usuario, $codigo_garita);
                Funciones::imprimeJSON(200, "Entrada rápida conductor", $resultado);
            break;
            case "VEHICULO":
                $separador = explode("#", $codigoQrDecoded);
                $codigo_vehiculo = explode("=", $separador[0]);
                $codigo_vehiculo = $codigo_vehiculo[1];
                $placa = explode("=", $separador[1]);
                $placa = $placa[1];
                $tipo_vehiculo = explode("=", $separador[4]);
                $tipo_vehiculo = $tipo_vehiculo[1];
                $codigo_empresa = explode("=", $separador[6]);
                $codigo_empresa = $codigo_empresa[1];
                $resultado = $obj->entradaRapidaVehiculo($codigo_vehiculo, $placa, $tipo_vehiculo, $codigo_empresa, $codigo_usuario, $codigo_garita);
                Funciones::imprimeJSON(200, "Entrada rápida vehiculo", $resultado);
            break;
            case "TRANSPORTISTA":
                $separador = explode('#', $codigoQrDecoded);

                $codigo_conductor = explode("=", $separador[11]);
                $codigo_conductor = $codigo_conductor[1];

                $codigo_empresa = explode("=", $separador[7]);
                $codigo_empresa = $codigo_empresa[1];

                $codigo_proveedor = explode("=", $separador[8]);
                $codigo_proveedor = $codigo_proveedor[1];

                $nombre_conductor = explode("=", $separador[12]);
                $nombre_conductor = $nombre_conductor[1];

                $dni_conductor = explode("=", $separador[16]);
                $dni_conductor = $dni_conductor[1];

                $codigo_ruta_transporte = explode("=", $separador[14]);
                $codigo_ruta_transporte = $codigo_ruta_transporte[1];

                $resultado = $obj->entradaRapidaConductor($codigo_conductor, $codigo_empresa, $nombre_conductor, $dni_conductor, $codigo_usuario, $codigo_garita, $codigo_proveedor, $codigo_ruta_transporte);
                Funciones::imprimeJSON(200, "Entrada rápida transportista", $resultado);
            break;
            case "EXPIRABLE":
                $separador = explode('#', $codigoQrDecoded);
                $fecha_inicio = explode("=", $separador[6]);
                $fecha_inicio = $fecha_inicio[1];
                $fecha_fin = explode("=", $separador[7]);
                $fecha_fin = $fecha_fin[1];
                // $hoy = date('2020-11-10');
                $hoy = date('Y-m-d');


                $hoy=date('Y-m-d', strtotime($hoy));
                $fecha_inicio = date('Y-m-d', strtotime($fecha_inicio));
                $fecha_fin = date('Y-m-d', strtotime($fecha_fin));

                if (($hoy >= $fecha_inicio) && ($hoy <= $fecha_fin)){ //Está dentro del rango de entrada permitido
                    $alerta = "";
                }else{
                    $alerta = "No tienes permitido el ingreso hoy. \nLas fechas permitidas para tu ingreso son: F. Ingreso: $fecha_inicio y F. Salida: $fecha_fin";
                }

                $codigo_conductor = explode("=", $separador[0]);
                $codigo_conductor = $codigo_conductor[1];
                $codigo_empresa = explode("=", $separador[1]);
                $codigo_empresa = $codigo_empresa[1];
                $nombre_conductor = explode("=", $separador[2]);
                $nombre_conductor = $nombre_conductor[1];
                $dni_conductor = explode("=", $separador[5]);
                $dni_conductor = $dni_conductor[1];

                $codigo_proveedor = explode("=", $separador[8]);
                $codigo_proveedor = $codigo_proveedor[1];
                $resultado = $obj->entradaRapidaConductor($codigo_conductor, $codigo_empresa, $nombre_conductor, $dni_conductor, $codigo_usuario, $codigo_garita, $codigo_proveedor);
                $resultado["alerta"] = $alerta;
                Funciones::imprimeJSON(200, "Entrada rápida expirable", $resultado);
            break;
            default:
                Funciones::imprimeJSON(200, "error", "Parece que ese QR no ha sido generado por Pro Olmos");
            break;
        }
    }
}catch(Exception $e){
    Funciones::imprimeJSON(200, "error", $e->getMessage());
}
