<?php
require __DIR__.'/../datos/Conexion.clase.php';
require __DIR__ . '/../util/definiciones.php';
date_default_timezone_set("America/Lima");

class Tracking extends Conexion {

    public function sincronizarTracking($trackingDetalle){
        $this->dblink->beginTransaction();
        try{
            foreach($trackingDetalle as $tracking){
                $fecha_servidor = date("Y-m-d");
                $hora_servidor = date("H:i:s");
                $codigo_off_line = $tracking["codigo_off_line"];
                $codigo_conductor = $tracking["codigo_conductor"];
                $placa = $tracking["placa"];
                $tipo_viaje = $tracking["tipo_viaje"];
                $latitud = $tracking["latitud"];
                $longitud = $tracking["longitud"];
                $velocidad_estimada = $tracking["velocidad_estimada"];
                $estado = $tracking["estado"];
                $fecha_registro = $tracking["fecha_registro"];
                $timestamp_servidor = "$fecha_servidor $hora_servidor";

                $sql = "SELECT * from tracking_conductor where codigo_off_line = ? and fecha_registro_dispositivo = ?;";
                $sentencia = $this->dblink->prepare($sql);
                $sentencia->bindParam(1,$codigo_off_line);
                $sentencia->bindParam(2,$fecha_registro);
                $sentencia->execute();

                if(!$sentencia->rowCount()){
                    $sql = "INSERT INTO tracking_conductor values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->bindParam(1, $codigo_off_line);
                    $sentencia->bindParam(2, $codigo_conductor);
                    $sentencia->bindParam(3, $placa);
                    $sentencia->bindParam(4, $tipo_viaje);
                    $sentencia->bindParam(5, $latitud);
                    $sentencia->bindParam(6, $longitud);
                    $sentencia->bindParam(7, $velocidad_estimada);
                    $sentencia->bindParam(8, $fecha_registro);
                    $sentencia->bindParam(9, $timestamp_servidor);
                    $sentencia->bindParam(10, $estado);
                    $sentencia->execute();
                }
            }
            $this->dblink->commit();
            return true;
        }catch(Exception $e){
            $this->dblink->rollBack();
            throw $e;
        }
    }

}